Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -500,58 +496,58 @@
 molecule *molecule::CopyMolecule()
 {
-	molecule *copy = new molecule(elemente);
-	atom *CurrentAtom = NULL;
-	atom *LeftAtom = NULL, *RightAtom = NULL;
-	atom *Walker = NULL;
-
-	// copy all atoms
-	Walker = start;
-	while(Walker->next != end) {
-		Walker = Walker->next;
-		CurrentAtom = copy->AddCopyAtom(Walker);
-	}
-
-	// copy all bonds
-	bond *Binder = first;
-	bond *NewBond = NULL;
-	while(Binder->next != last) {
-		Binder = Binder->next;
-		// get the pendant atoms of current bond in the copy molecule
-		LeftAtom = copy->start;
-		while (LeftAtom->next != copy->end) {
-			LeftAtom = LeftAtom->next;
-			if (LeftAtom->father == Binder->leftatom)
-				break;
-		}
-		RightAtom = copy->start;
-		while (RightAtom->next != copy->end) {
-			RightAtom = RightAtom->next;
-			if (RightAtom->father == Binder->rightatom)
-				break;
-		}
-		NewBond = copy->AddBond(LeftAtom, RightAtom, Binder->BondDegree);
-		NewBond->Cyclic = Binder->Cyclic;
-		if (Binder->Cyclic)
-			copy->NoCyclicBonds++;
-		NewBond->Type = Binder->Type;
-	}
-	// correct fathers
-	Walker = copy->start;
-	while(Walker->next != copy->end) {
-		Walker = Walker->next;
-		if (Walker->father->father == Walker->father)	 // same atom in copy's father points to itself
-			Walker->father = Walker;	// set father to itself (copy of a whole molecule)
-		else
-		 Walker->father = Walker->father->father;	// set father to original's father
-	}
-	// copy values
-	copy->CountAtoms((ofstream *)&cout);
-	copy->CountElements();
-	if (first->next != last) {	// if adjaceny list is present
-		copy->BondDistance = BondDistance;
-		copy->CreateListOfBondsPerAtom((ofstream *)&cout);
-	}
-
-	return copy;
+  molecule *copy = new molecule(elemente);
+  atom *CurrentAtom = NULL;
+  atom *LeftAtom = NULL, *RightAtom = NULL;
+  atom *Walker = NULL;
+
+  // copy all atoms
+  Walker = start;
+  while(Walker->next != end) {
+    Walker = Walker->next;
+    CurrentAtom = copy->AddCopyAtom(Walker);
+  }
+
+  // copy all bonds
+  bond *Binder = first;
+  bond *NewBond = NULL;
+  while(Binder->next != last) {
+    Binder = Binder->next;
+    // get the pendant atoms of current bond in the copy molecule
+    LeftAtom = copy->start;
+    while (LeftAtom->next != copy->end) {
+      LeftAtom = LeftAtom->next;
+      if (LeftAtom->father == Binder->leftatom)
+        break;
+    }
+    RightAtom = copy->start;
+    while (RightAtom->next != copy->end) {
+      RightAtom = RightAtom->next;
+      if (RightAtom->father == Binder->rightatom)
+        break;
+    }
+    NewBond = copy->AddBond(LeftAtom, RightAtom, Binder->BondDegree);
+    NewBond->Cyclic = Binder->Cyclic;
+    if (Binder->Cyclic)
+      copy->NoCyclicBonds++;
+    NewBond->Type = Binder->Type;
+  }
+  // correct fathers
+  Walker = copy->start;
+  while(Walker->next != copy->end) {
+    Walker = Walker->next;
+    if (Walker->father->father == Walker->father)   // same atom in copy's father points to itself
+      Walker->father = Walker;  // set father to itself (copy of a whole molecule)
+    else
+     Walker->father = Walker->father->father;  // set father to original's father
+  }
+  // copy values
+  copy->CountAtoms((ofstream *)&cout);
+  copy->CountElements();
+  if (first->next != last) {  // if adjaceny list is present
+    copy->BondDistance = BondDistance;
+    copy->CreateListOfBondsPerAtom((ofstream *)&cout);
+  }
+
+  return copy;
 };
 
@@ -564,14 +560,14 @@
 bond * molecule::AddBond(atom *atom1, atom *atom2, int degree=1)
 {
-	bond *Binder = NULL;
-	if ((atom1 != NULL) && (FindAtom(atom1->nr) != NULL) && (atom2 != NULL) && (FindAtom(atom2->nr) != NULL)) {
-		Binder = new bond(atom1, atom2, degree, BondCount++);
-		if ((atom1->type != NULL) && (atom1->type->Z != 1) && (atom2->type != NULL) && (atom2->type->Z != 1))
-			NoNonBonds++;
-		add(Binder, last);
-	} else {
-		cerr << Verbose(1) << "ERROR: Could not add bond between " << atom1->Name << " and " << atom2->Name << " as one or both are not present in the molecule." << endl;
-	}
-	return Binder;
+  bond *Binder = NULL;
+  if ((atom1 != NULL) && (FindAtom(atom1->nr) != NULL) && (atom2 != NULL) && (FindAtom(atom2->nr) != NULL)) {
+    Binder = new bond(atom1, atom2, degree, BondCount++);
+    if ((atom1->type != NULL) && (atom1->type->Z != 1) && (atom2->type != NULL) && (atom2->type->Z != 1))
+      NoNonBonds++;
+    add(Binder, last);
+  } else {
+    cerr << Verbose(1) << "ERROR: Could not add bond between " << atom1->Name << " and " << atom2->Name << " as one or both are not present in the molecule." << endl;
+  }
+  return Binder;
 };
 
@@ -583,7 +579,7 @@
 bool molecule::RemoveBond(bond *pointer)
 {
-	//cerr << Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl;
-	removewithoutcheck(pointer);
-	return true;
+  //cerr << Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl;
+  removewithoutcheck(pointer);
+  return true;
 };
 
@@ -595,6 +591,6 @@
 bool molecule::RemoveBonds(atom *BondPartner)
 {
-	cerr << Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl;
-	return false;
+  cerr << Verbose(1) << "molecule::RemoveBond: Function not implemented yet." << endl;
+  return false;
 };
 
@@ -602,9 +598,9 @@
  * \param *filename filename
  */
-void molecule::SetNameFromFilename(char *filename)
+void molecule::SetNameFromFilename(const char *filename)
 {
   int length = 0;
   char *molname = strrchr(filename, '/')+sizeof(char);  // search for filename without dirs
-  char *endname = strrchr(filename, '.');
+  char *endname = strchr(molname, '.');
   if ((endname == NULL) || (endname < molname))
     length = strlen(molname);
@@ -612,4 +608,5 @@
     length = strlen(molname) - strlen(endname);
   strncpy(name, molname, length);
+  name[length]='\0';
 };
 
@@ -619,59 +616,59 @@
 void molecule::SetBoxDimension(Vector *dim)
 {
-	cell_size[0] = dim->x[0];
-	cell_size[1] = 0.;
-	cell_size[2] = dim->x[1];
-	cell_size[3] = 0.;
-	cell_size[4] = 0.;
-	cell_size[5] = dim->x[2];
+  cell_size[0] = dim->x[0];
+  cell_size[1] = 0.;
+  cell_size[2] = dim->x[1];
+  cell_size[3] = 0.;
+  cell_size[4] = 0.;
+  cell_size[5] = dim->x[2];
 };
 
 /** Centers the molecule in the box whose lengths are defined by vector \a *BoxLengths.
  * \param *out output stream for debugging
- * \param *BoxLengths box lengths
- */
-bool molecule::CenterInBox(ofstream *out, Vector *BoxLengths)
-{
-	bool status = true;
-	atom *ptr = NULL;
-	Vector *min = new Vector;
-	Vector *max = new Vector;
-
-	// gather min and max for each axis
-	ptr = start->next;	// start at first in list
-	if (ptr != end) {	 //list not empty?
-		for (int i=NDIM;i--;) {
-			max->x[i] = ptr->x.x[i];
-			min->x[i] = ptr->x.x[i];
-		}
-		while (ptr->next != end) {	// continue with second if present
-			ptr = ptr->next;
-			//ptr->Output(1,1,out);
-			for (int i=NDIM;i--;) {
-				max->x[i] = (max->x[i] < ptr->x.x[i]) ? ptr->x.x[i] : max->x[i];
-				min->x[i] = (min->x[i] > ptr->x.x[i]) ? ptr->x.x[i] : min->x[i];
-			}
-		}
-	}
-	// sanity check
-	for(int i=NDIM;i--;) {
-		if (max->x[i] - min->x[i] > BoxLengths->x[i])
-			status = false;
-	}
-	// warn if check failed
-	if (!status)
-		*out << "WARNING: molecule is bigger than defined box!" << endl;
-	else {	// else center in box
-		max->AddVector(min);
-		max->Scale(-1.);
-		max->AddVector(BoxLengths);
-		max->Scale(0.5);
-		Translate(max);
-	}
-
-	// free and exit
-	delete(min);
-	delete(max);
-	return status;
+ */
+bool molecule::CenterInBox(ofstream *out)
+{
+  bool status = true;
+  atom *ptr = NULL;
+  Vector x;
+  double *M = ReturnFullMatrixforSymmetric(cell_size);
+  double *Minv = x.InverseMatrix(M);
+  double value;
+
+//  cout << "The box matrix is :" << endl;
+//  for (int i=0;i<NDIM;++i) {
+//    for (int j=0;j<NDIM;++j)
+//      cout << M[i*NDIM+j] << "\t";
+//    cout << endl;
+//  }
+//  cout << "And its inverse is :" << endl;
+//  for (int i=0;i<NDIM;++i) {
+//    for (int j=0;j<NDIM;++j)
+//      cout << Minv[i*NDIM+j] << "\t";
+//    cout << endl;
+//  }
+  // go through all atoms
+  ptr = start->next;  // start at first in list
+  if (ptr != end) {  //list not empty?
+    while (ptr->next != end) {  // continue with second if present
+      ptr = ptr->next;
+      //ptr->Output(1,1,out);
+      // multiply its vector with matrix inverse
+      x.CopyVector(&ptr->x);
+      x.MatrixMultiplication(Minv);
+      // truncate to [0,1] for each axis
+      for (int i=0;i<NDIM;i++) {
+        value = floor(x.x[i]);  // next lower integer
+        if (x.x[i] >=0) {
+          x.x[i] -= value;
+        } else {
+          x.x[i] += value+1;
+        }
+      }
+    }
+  }
+  delete(M);
+  delete(Minv);
+  return status;
 };
 
@@ -682,32 +679,33 @@
 void molecule::CenterEdge(ofstream *out, Vector *max)
 {
-	Vector *min = new Vector;
-
-//	*out << Verbose(3) << "Begin of CenterEdge." << endl;
-	atom *ptr = start->next;	// start at first in list
-	if (ptr != end) {	 //list not empty?
-		for (int i=NDIM;i--;) {
-			max->x[i] = ptr->x.x[i];
-			min->x[i] = ptr->x.x[i];
-		}
-		while (ptr->next != end) {	// continue with second if present
-			ptr = ptr->next;
-			//ptr->Output(1,1,out);
-			for (int i=NDIM;i--;) {
-				max->x[i] = (max->x[i] < ptr->x.x[i]) ? ptr->x.x[i] : max->x[i];
-				min->x[i] = (min->x[i] > ptr->x.x[i]) ? ptr->x.x[i] : min->x[i];
-			}
-		}
-//		*out << Verbose(4) << "Maximum is ";
-//		max->Output(out);
-//		*out << ", Minimum is ";
-//		min->Output(out);
-//		*out << endl;
-		min->Scale(-1.);
-		max->AddVector(min);
-		Translate(min);
-	}
-	delete(min);
-//	*out << Verbose(3) << "End of CenterEdge." << endl;
+  Vector *min = new Vector;
+
+//  *out << Verbose(3) << "Begin of CenterEdge." << endl;
+  atom *ptr = start->next;  // start at first in list
+  if (ptr != end) {   //list not empty?
+    for (int i=NDIM;i--;) {
+      max->x[i] = ptr->x.x[i];
+      min->x[i] = ptr->x.x[i];
+    }
+    while (ptr->next != end) {  // continue with second if present
+      ptr = ptr->next;
+      //ptr->Output(1,1,out);
+      for (int i=NDIM;i--;) {
+        max->x[i] = (max->x[i] < ptr->x.x[i]) ? ptr->x.x[i] : max->x[i];
+        min->x[i] = (min->x[i] > ptr->x.x[i]) ? ptr->x.x[i] : min->x[i];
+      }
+    }
+//    *out << Verbose(4) << "Maximum is ";
+//    max->Output(out);
+//    *out << ", Minimum is ";
+//    min->Output(out);
+//    *out << endl;
+    min->Scale(-1.);
+    max->AddVector(min);
+    Translate(min);
+    Center.Zero();
+  }
+  delete(min);
+//  *out << Verbose(3) << "End of CenterEdge." << endl;
 };
 
@@ -716,21 +714,49 @@
  * \param *center return vector for translation vector
  */
-void molecule::CenterOrigin(ofstream *out, Vector *center)
-{
-	int Num = 0;
-	atom *ptr = start->next;	// start at first in list
-
-	for(int i=NDIM;i--;) // zero center vector
-		center->x[i] = 0.;
-
-	if (ptr != end) {	 //list not empty?
-		while (ptr->next != end) {	// continue with second if present
-			ptr = ptr->next;
-			Num++;
-			center->AddVector(&ptr->x);
-		}
-		center->Scale(-1./Num); // divide through total number (and sign for direction)
-		Translate(center);
-	}
+void molecule::CenterOrigin(ofstream *out)
+{
+  int Num = 0;
+  atom *ptr = start->next;  // start at first in list
+
+  Center.Zero();
+
+  if (ptr != end) {   //list not empty?
+    while (ptr->next != end) {  // continue with second if present
+      ptr = ptr->next;
+      Num++;
+      Center.AddVector(&ptr->x);
+    }
+    Center.Scale(-1./Num); // divide through total number (and sign for direction)
+    Translate(&Center);
+    Center.Zero();
+  }
+};
+
+/** Returns vector pointing to center of all atoms.
+ * \param *out output stream for debugging
+ * \return pointer to center of all vector
+ */
+Vector * molecule::DetermineCenterOfAll(ofstream *out)
+{
+  atom *ptr = start->next;  // start at first in list
+  Vector *a = new Vector();
+  Vector tmp;
+  double Num = 0;
+
+  a->Zero();
+
+  if (ptr != end) {   //list not empty?
+    while (ptr->next != end) {  // continue with second if present
+      ptr = ptr->next;
+      Num += 1.;
+      tmp.CopyVector(&ptr->x);
+      a->AddVector(&tmp);
+    }
+    a->Scale(1./Num); // divide through total mass (and sign for direction)
+  }
+  //cout << Verbose(1) << "Resulting center of gravity: ";
+  //a->Output(out);
+  //cout << endl;
+  return a;
 };
 
@@ -739,55 +765,27 @@
  * \return pointer to center of gravity vector
  */
-Vector * molecule::DetermineCenterOfAll(ofstream *out)
-{
-	atom *ptr = start->next;	// start at first in list
-	Vector *a = new Vector();
-	Vector tmp;
-	double Num = 0;
-
-	a->Zero();
-
-	if (ptr != end) {	 //list not empty?
-		while (ptr->next != end) {	// continue with second if present
-			ptr = ptr->next;
-			Num += 1.;
-			tmp.CopyVector(&ptr->x);
-			a->AddVector(&tmp);
-		}
-		a->Scale(-1./Num); // divide through total mass (and sign for direction)
-	}
-	//cout << Verbose(1) << "Resulting center of gravity: ";
-	//a->Output(out);
-	//cout << endl;
-	return a;
-};
-
-/** Returns vector pointing to center of gravity.
- * \param *out output stream for debugging
- * \return pointer to center of gravity vector
- */
 Vector * molecule::DetermineCenterOfGravity(ofstream *out)
 {
-	atom *ptr = start->next;	// start at first in list
-	Vector *a = new Vector();
-	Vector tmp;
-	double Num = 0;
-
-	a->Zero();
-
-	if (ptr != end) {	 //list not empty?
-		while (ptr->next != end) {	// continue with second if present
-			ptr = ptr->next;
-			Num += ptr->type->mass;
-			tmp.CopyVector(&ptr->x);
-			tmp.Scale(ptr->type->mass);	// scale by mass
-			a->AddVector(&tmp);
-		}
-		a->Scale(-1./Num); // divide through total mass (and sign for direction)
-	}
-//	*out << Verbose(1) << "Resulting center of gravity: ";
-//	a->Output(out);
-//	*out << endl;
-	return a;
+  atom *ptr = start->next;  // start at first in list
+  Vector *a = new Vector();
+  Vector tmp;
+  double Num = 0;
+
+  a->Zero();
+
+  if (ptr != end) {   //list not empty?
+    while (ptr->next != end) {  // continue with second if present
+      ptr = ptr->next;
+      Num += ptr->type->mass;
+      tmp.CopyVector(&ptr->x);
+      tmp.Scale(ptr->type->mass);  // scale by mass
+      a->AddVector(&tmp);
+    }
+    a->Scale(-1./Num); // divide through total mass (and sign for direction)
+  }
+//  *out << Verbose(1) << "Resulting center of gravity: ";
+//  a->Output(out);
+//  *out << endl;
+  return a;
 };
 
@@ -796,14 +794,19 @@
  * \param *center return vector for translation vector
  */
-void molecule::CenterGravity(ofstream *out, Vector *center)
-{
-	if (center == NULL) {
-		DetermineCenter(*center);
-		Translate(center);
-		delete(center);
-	} else {
-		Translate(center);
-	}
-};
+void molecule::CenterPeriodic(ofstream *out)
+{
+  DeterminePeriodicCenter(Center);
+};
+
+
+/** Centers the center of gravity of the atoms at (0,0,0).
+ * \param *out output stream for debugging
+ * \param *center return vector for translation vector
+ */
+void molecule::CenterAtVector(ofstream *out, Vector *newcenter)
+{
+  Center.CopyVector(newcenter);
+};
+
 
 /** Scales all atoms by \a *factor.
@@ -812,12 +815,12 @@
 void molecule::Scale(double **factor)
 {
-	atom *ptr = start;
-
-	while (ptr->next != end) {
-		ptr = ptr->next;
-		for (int j=0;j<MDSteps;j++)
-			Trajectories[ptr].R.at(j).Scale(factor);
-		ptr->x.Scale(factor);
-	}
+  atom *ptr = start;
+
+  while (ptr->next != end) {
+    ptr = ptr->next;
+    for (int j=0;j<MDSteps;j++)
+      Trajectories[ptr].R.at(j).Scale(factor);
+    ptr->x.Scale(factor);
+  }
 };
 
@@ -827,13 +830,68 @@
 void molecule::Translate(const Vector *trans)
 {
-	atom *ptr = start;
-
-	while (ptr->next != end) {
-		ptr = ptr->next;
-		for (int j=0;j<MDSteps;j++)
-			Trajectories[ptr].R.at(j).Translate(trans);
-		ptr->x.Translate(trans);
-	}
-};
+  atom *ptr = start;
+
+  while (ptr->next != end) {
+    ptr = ptr->next;
+    for (int j=0;j<MDSteps;j++)
+      Trajectories[ptr].R.at(j).Translate(trans);
+    ptr->x.Translate(trans);
+  }
+};
+
+/** Translate the molecule periodically in the box.
+ * \param trans[] translation vector.
+ */
+void molecule::TranslatePeriodically(const Vector *trans)
+{
+  atom *ptr = NULL;
+  Vector x;
+  double *M = ReturnFullMatrixforSymmetric(cell_size);
+  double *Minv = x.InverseMatrix(M);
+  double value;
+
+  // go through all atoms
+  ptr = start->next;  // start at first in list
+  while (ptr != end) {  // continue with second if present
+    //ptr->Output(1,1,out);
+    // multiply its vector with matrix inverse
+    x.CopyVector(&ptr->x);
+    x.Translate(trans);
+    x.MatrixMultiplication(Minv);
+    // truncate to [0,1] for each axis
+    for (int i=0;i<NDIM;i++) {
+      value = floor(fabs(x.x[i]));  // next lower integer
+      if (x.x[i] >=0) {
+        x.x[i] -= value;
+      } else {
+        x.x[i] += value+1;
+      }
+    }
+    // matrix multiply
+    x.MatrixMultiplication(M);
+    ptr->x.CopyVector(&x);
+    for (int j=0;j<MDSteps;j++) {
+      x.CopyVector(&Trajectories[ptr].R.at(j));
+      x.Translate(trans);
+      x.MatrixMultiplication(Minv);
+      // truncate to [0,1] for each axis
+      for (int i=0;i<NDIM;i++) {
+        value = floor(x.x[i]);  // next lower integer
+        if (x.x[i] >=0) {
+          x.x[i] -= value;
+        } else {
+          x.x[i] += value+1;
+        }
+      }
+      // matrix multiply
+      x.MatrixMultiplication(M);
+      Trajectories[ptr].R.at(j).CopyVector(&x);
+    }
+    ptr = ptr->next;
+  }
+  delete(M);
+  delete(Minv);
+};
+
 
 /** Mirrors all atoms against a given plane.
@@ -842,79 +900,79 @@
 void molecule::Mirror(const Vector *n)
 {
-	atom *ptr = start;
-
-	while (ptr->next != end) {
-		ptr = ptr->next;
-		for (int j=0;j<MDSteps;j++)
-			Trajectories[ptr].R.at(j).Mirror(n);
-		ptr->x.Mirror(n);
-	}
+  atom *ptr = start;
+
+  while (ptr->next != end) {
+    ptr = ptr->next;
+    for (int j=0;j<MDSteps;j++)
+      Trajectories[ptr].R.at(j).Mirror(n);
+    ptr->x.Mirror(n);
+  }
 };
 
 /** Determines center of molecule (yet not considering atom masses).
- * \param Center reference to return vector
- */
-void molecule::DetermineCenter(Vector &Center)
-{
-	atom *Walker = start;
-	bond *Binder = NULL;
-	double *matrix = ReturnFullMatrixforSymmetric(cell_size);
-	double tmp;
-	bool flag;
-	Vector Testvector, Translationvector;
-
-	do {
-		Center.Zero();
-		flag = true;
-		while (Walker->next != end) {
-			Walker = Walker->next;
+ * \param center reference to return vector
+ */
+void molecule::DeterminePeriodicCenter(Vector &center)
+{
+  atom *Walker = start;
+  bond *Binder = NULL;
+  double *matrix = ReturnFullMatrixforSymmetric(cell_size);
+  double tmp;
+  bool flag;
+  Vector Testvector, Translationvector;
+
+  do {
+    Center.Zero();
+    flag = true;
+    while (Walker->next != end) {
+      Walker = Walker->next;
 #ifdef ADDHYDROGEN
-			if (Walker->type->Z != 1) {
+      if (Walker->type->Z != 1) {
 #endif
-				Testvector.CopyVector(&Walker->x);
-				Testvector.InverseMatrixMultiplication(matrix);
-				Translationvector.Zero();
-				for (int i=0;i<NumberOfBondsPerAtom[Walker->nr]; i++) {
-					Binder = ListOfBondsPerAtom[Walker->nr][i];
-					if (Walker->nr < Binder->GetOtherAtom(Walker)->nr) // otherwise we shift one to, the other fro and gain nothing
-						for (int j=0;j<NDIM;j++) {
-							tmp = Walker->x.x[j] - Binder->GetOtherAtom(Walker)->x.x[j];
-							if ((fabs(tmp)) > BondDistance) {
-								flag = false;
-								cout << Verbose(0) << "Hit: atom " << Walker->Name << " in bond " << *Binder << " has to be shifted due to " << tmp << "." << endl;
-								if (tmp > 0)
-									Translationvector.x[j] -= 1.;
-								else
-									Translationvector.x[j] += 1.;
-							}
-						}
-				}
-				Testvector.AddVector(&Translationvector);
-				Testvector.MatrixMultiplication(matrix);
-				Center.AddVector(&Testvector);
-				cout << Verbose(1) << "vector is: ";
-				Testvector.Output((ofstream *)&cout);
-				cout << endl;
+        Testvector.CopyVector(&Walker->x);
+        Testvector.InverseMatrixMultiplication(matrix);
+        Translationvector.Zero();
+        for (int i=0;i<NumberOfBondsPerAtom[Walker->nr]; i++) {
+          Binder = ListOfBondsPerAtom[Walker->nr][i];
+          if (Walker->nr < Binder->GetOtherAtom(Walker)->nr) // otherwise we shift one to, the other fro and gain nothing
+            for (int j=0;j<NDIM;j++) {
+              tmp = Walker->x.x[j] - Binder->GetOtherAtom(Walker)->x.x[j];
+              if ((fabs(tmp)) > BondDistance) {
+                flag = false;
+                cout << Verbose(0) << "Hit: atom " << Walker->Name << " in bond " << *Binder << " has to be shifted due to " << tmp << "." << endl;
+                if (tmp > 0)
+                  Translationvector.x[j] -= 1.;
+                else
+                  Translationvector.x[j] += 1.;
+              }
+            }
+        }
+        Testvector.AddVector(&Translationvector);
+        Testvector.MatrixMultiplication(matrix);
+        Center.AddVector(&Testvector);
+        cout << Verbose(1) << "vector is: ";
+        Testvector.Output((ofstream *)&cout);
+        cout << endl;
 #ifdef ADDHYDROGEN
-				// now also change all hydrogens
-				for (int i=0;i<NumberOfBondsPerAtom[Walker->nr]; i++) {
-					Binder = ListOfBondsPerAtom[Walker->nr][i];
-					if (Binder->GetOtherAtom(Walker)->type->Z == 1) {
-						Testvector.CopyVector(&Binder->GetOtherAtom(Walker)->x);
-						Testvector.InverseMatrixMultiplication(matrix);
-						Testvector.AddVector(&Translationvector);
-						Testvector.MatrixMultiplication(matrix);
-						Center.AddVector(&Testvector);
-						cout << Verbose(1) << "Hydrogen vector is: ";
-						Testvector.Output((ofstream *)&cout);
-						cout << endl;
-					}
-				}
-			}
+        // now also change all hydrogens
+        for (int i=0;i<NumberOfBondsPerAtom[Walker->nr]; i++) {
+          Binder = ListOfBondsPerAtom[Walker->nr][i];
+          if (Binder->GetOtherAtom(Walker)->type->Z == 1) {
+            Testvector.CopyVector(&Binder->GetOtherAtom(Walker)->x);
+            Testvector.InverseMatrixMultiplication(matrix);
+            Testvector.AddVector(&Translationvector);
+            Testvector.MatrixMultiplication(matrix);
+            Center.AddVector(&Testvector);
+            cout << Verbose(1) << "Hydrogen vector is: ";
+            Testvector.Output((ofstream *)&cout);
+            cout << endl;
+          }
+        }
+      }
 #endif
-		}
-	} while (!flag);
-	Free((void **)&matrix, "molecule::DetermineCenter: *matrix");
-	Center.Scale(1./(double)AtomCount);
+    }
+  } while (!flag);
+  Free((void **)&matrix, "molecule::DetermineCenter: *matrix");
+  Center.Scale(1./(double)AtomCount);
 };
 
